/*
 * This file is generated by jOOQ.
 */
package com.alkemy.sophia.ripartizione.dbmodel.jooq.tables;


import com.alkemy.sophia.ripartizione.dbmodel.jooq.DefaultSchema;
import com.alkemy.sophia.ripartizione.dbmodel.jooq.Indexes;
import com.alkemy.sophia.ripartizione.dbmodel.jooq.Keys;
import com.alkemy.sophia.ripartizione.dbmodel.jooq.tables.records.CcidMetadataRecord;

import java.math.BigDecimal;
import java.util.Arrays;
import java.util.List;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.Index;
import org.jooq.Name;
import org.jooq.Record;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.11.9"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class CcidMetadata extends TableImpl<CcidMetadataRecord> {

    private static final long serialVersionUID = -305487050;

    /**
     * The reference instance of <code>CCID_METADATA</code>
     */
    public static final CcidMetadata CCID_METADATA = new CcidMetadata();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<CcidMetadataRecord> getRecordType() {
        return CcidMetadataRecord.class;
    }

    /**
     * The column <code>CCID_METADATA.ID_CCID</code>.
     */
    public final TableField<CcidMetadataRecord, String> ID_CCID = createField("ID_CCID", org.jooq.impl.SQLDataType.VARCHAR(50).nullable(false), this, "");

    /**
     * The column <code>CCID_METADATA.ID_DSR</code>.
     */
    public final TableField<CcidMetadataRecord, String> ID_DSR = createField("ID_DSR", org.jooq.impl.SQLDataType.VARCHAR(512), this, "");

    /**
     * The column <code>CCID_METADATA.TOTAL_VALUE</code>.
     */
    public final TableField<CcidMetadataRecord, BigDecimal> TOTAL_VALUE = createField("TOTAL_VALUE", org.jooq.impl.SQLDataType.DECIMAL(34, 20).nullable(false), this, "");

    /**
     * The column <code>CCID_METADATA.ID_CCID_METADATA</code>.
     */
    public final TableField<CcidMetadataRecord, Long> ID_CCID_METADATA = createField("ID_CCID_METADATA", org.jooq.impl.SQLDataType.BIGINT.nullable(false).identity(true), this, "");

    /**
     * The column <code>CCID_METADATA.CURRENCY</code>.
     */
    public final TableField<CcidMetadataRecord, String> CURRENCY = createField("CURRENCY", org.jooq.impl.SQLDataType.VARCHAR(3).nullable(false), this, "");

    /**
     * The column <code>CCID_METADATA.CCID_VERSION</code>.
     */
    public final TableField<CcidMetadataRecord, String> CCID_VERSION = createField("CCID_VERSION", org.jooq.impl.SQLDataType.VARCHAR(45).nullable(false), this, "");

    /**
     * The column <code>CCID_METADATA.CCID_ENCODED</code>.
     */
    public final TableField<CcidMetadataRecord, Byte> CCID_ENCODED = createField("CCID_ENCODED", org.jooq.impl.SQLDataType.TINYINT.nullable(false), this, "");

    /**
     * The column <code>CCID_METADATA.CCID_ENCODED_PROVISIONAL</code>.
     */
    public final TableField<CcidMetadataRecord, Byte> CCID_ENCODED_PROVISIONAL = createField("CCID_ENCODED_PROVISIONAL", org.jooq.impl.SQLDataType.TINYINT.nullable(false), this, "");

    /**
     * The column <code>CCID_METADATA.CCID_NOT_ENCODED</code>.
     */
    public final TableField<CcidMetadataRecord, Byte> CCID_NOT_ENCODED = createField("CCID_NOT_ENCODED", org.jooq.impl.SQLDataType.TINYINT.nullable(false), this, "");

    /**
     * The column <code>CCID_METADATA.INVOICE_STATUS</code>.
     */
    public final TableField<CcidMetadataRecord, String> INVOICE_STATUS = createField("INVOICE_STATUS", org.jooq.impl.SQLDataType.VARCHAR(45).nullable(false).defaultValue(org.jooq.impl.DSL.inline("DA_FATTURARE", org.jooq.impl.SQLDataType.VARCHAR)), this, "");

    /**
     * The column <code>CCID_METADATA.INVOICE_ITEM</code>.
     */
    public final TableField<CcidMetadataRecord, Integer> INVOICE_ITEM = createField("INVOICE_ITEM", org.jooq.impl.SQLDataType.INTEGER, this, "");

    /**
     * The column <code>CCID_METADATA.VALORE_FATTURABILE</code>.
     */
    public final TableField<CcidMetadataRecord, BigDecimal> VALORE_FATTURABILE = createField("VALORE_FATTURABILE", org.jooq.impl.SQLDataType.DECIMAL(34, 20), this, "");

    /**
     * The column <code>CCID_METADATA.SUM_USE_QUANTITY</code>.
     */
    public final TableField<CcidMetadataRecord, Long> SUM_USE_QUANTITY = createField("SUM_USE_QUANTITY", org.jooq.impl.SQLDataType.BIGINT, this, "");

    /**
     * The column <code>CCID_METADATA.SUM_USE_QUANTITY_MATCHED</code>.
     */
    public final TableField<CcidMetadataRecord, Long> SUM_USE_QUANTITY_MATCHED = createField("SUM_USE_QUANTITY_MATCHED", org.jooq.impl.SQLDataType.BIGINT, this, "");

    /**
     * The column <code>CCID_METADATA.SUM_USE_QUANTITY_UNMATCHED</code>.
     */
    public final TableField<CcidMetadataRecord, Long> SUM_USE_QUANTITY_UNMATCHED = createField("SUM_USE_QUANTITY_UNMATCHED", org.jooq.impl.SQLDataType.BIGINT, this, "");

    /**
     * The column <code>CCID_METADATA.SUM_AMOUNT_LICENSOR</code>.
     */
    public final TableField<CcidMetadataRecord, BigDecimal> SUM_AMOUNT_LICENSOR = createField("SUM_AMOUNT_LICENSOR", org.jooq.impl.SQLDataType.DECIMAL(34, 20), this, "");

    /**
     * The column <code>CCID_METADATA.SUM_AMOUNT_PAI</code>.
     */
    public final TableField<CcidMetadataRecord, BigDecimal> SUM_AMOUNT_PAI = createField("SUM_AMOUNT_PAI", org.jooq.impl.SQLDataType.DECIMAL(34, 20), this, "");

    /**
     * The column <code>CCID_METADATA.SUM_AMOUNT_UNMATCHED</code>.
     */
    public final TableField<CcidMetadataRecord, BigDecimal> SUM_AMOUNT_UNMATCHED = createField("SUM_AMOUNT_UNMATCHED", org.jooq.impl.SQLDataType.DECIMAL(34, 20), this, "");

    /**
     * The column <code>CCID_METADATA.SUM_USE_QUANTITY_SIAE</code>.
     */
    public final TableField<CcidMetadataRecord, BigDecimal> SUM_USE_QUANTITY_SIAE = createField("SUM_USE_QUANTITY_SIAE", org.jooq.impl.SQLDataType.DECIMAL(34, 20), this, "");

    /**
     * The column <code>CCID_METADATA.VALORE_RESIDUO</code>.
     */
    public final TableField<CcidMetadataRecord, BigDecimal> VALORE_RESIDUO = createField("VALORE_RESIDUO", org.jooq.impl.SQLDataType.DECIMAL(34, 20), this, "");

    /**
     * The column <code>CCID_METADATA.QUOTA_FATTURA</code>.
     */
    public final TableField<CcidMetadataRecord, BigDecimal> QUOTA_FATTURA = createField("QUOTA_FATTURA", org.jooq.impl.SQLDataType.DECIMAL(34, 20), this, "");

    /**
     * The column <code>CCID_METADATA.IDENTIFICATO_VALORE_PRICING</code>.
     */
    public final TableField<CcidMetadataRecord, BigDecimal> IDENTIFICATO_VALORE_PRICING = createField("IDENTIFICATO_VALORE_PRICING", org.jooq.impl.SQLDataType.DECIMAL(34, 20), this, "");

    /**
     * The column <code>CCID_METADATA.TOTAL_VALUE_CCID_CURRENCY</code>.
     */
    public final TableField<CcidMetadataRecord, BigDecimal> TOTAL_VALUE_CCID_CURRENCY = createField("TOTAL_VALUE_CCID_CURRENCY", org.jooq.impl.SQLDataType.DECIMAL(34, 20), this, "");

    /**
     * Create a <code>CCID_METADATA</code> table reference
     */
    public CcidMetadata() {
        this(DSL.name("CCID_METADATA"), null);
    }

    /**
     * Create an aliased <code>CCID_METADATA</code> table reference
     */
    public CcidMetadata(String alias) {
        this(DSL.name(alias), CCID_METADATA);
    }

    /**
     * Create an aliased <code>CCID_METADATA</code> table reference
     */
    public CcidMetadata(Name alias) {
        this(alias, CCID_METADATA);
    }

    private CcidMetadata(Name alias, Table<CcidMetadataRecord> aliased) {
        this(alias, aliased, null);
    }

    private CcidMetadata(Name alias, Table<CcidMetadataRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, DSL.comment(""));
    }

    public <O extends Record> CcidMetadata(Table<O> child, ForeignKey<O, CcidMetadataRecord> key) {
        super(child, key, CCID_METADATA);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Schema getSchema() {
        return DefaultSchema.DEFAULT_SCHEMA;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<Index> getIndexes() {
        return Arrays.<Index>asList(Indexes.CCID_METADATA_FK_ID_DSR_CCID_METADATA_IDX, Indexes.CCID_METADATA_FK_ID_INVOICE_ITEM_CCID_METADATA, Indexes.CCID_METADATA_IDX_UQ__CCID_DSR_CCID_METADATA, Indexes.CCID_METADATA_PRIMARY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Identity<CcidMetadataRecord, Long> getIdentity() {
        return Keys.IDENTITY_CCID_METADATA;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public UniqueKey<CcidMetadataRecord> getPrimaryKey() {
        return Keys.KEY_CCID_METADATA_PRIMARY;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<UniqueKey<CcidMetadataRecord>> getKeys() {
        return Arrays.<UniqueKey<CcidMetadataRecord>>asList(Keys.KEY_CCID_METADATA_IDX_UQ__CCID_DSR_CCID_METADATA, Keys.KEY_CCID_METADATA_PRIMARY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<ForeignKey<CcidMetadataRecord, ?>> getReferences() {
        return Arrays.<ForeignKey<CcidMetadataRecord, ?>>asList(Keys.FK_ID_DSR_CCID_METADATA, Keys.FK_ID_INVOICE_ITEM_CCID_METADATA);
    }

    public DsrMetadata dsrMetadata() {
        return new DsrMetadata(this, Keys.FK_ID_DSR_CCID_METADATA);
    }

    public InvoiceItem invoiceItem() {
        return new InvoiceItem(this, Keys.FK_ID_INVOICE_ITEM_CCID_METADATA);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public CcidMetadata as(String alias) {
        return new CcidMetadata(DSL.name(alias), this);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public CcidMetadata as(Name alias) {
        return new CcidMetadata(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public CcidMetadata rename(String name) {
        return new CcidMetadata(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public CcidMetadata rename(Name name) {
        return new CcidMetadata(name, null);
    }
}
